/* gcc -c -O -Wall adc.c */

#define MODULE
#define __KERNEL__
#include <linux/module.h>
#include <linux/kernel.h> /* printk() */
#include <linux/fs.h>     /* everything... */
#include <linux/ioport.h> /* request_region ... */

#include <asm/io.h>        /* outb and inb */

/* in <linux/major.h> : #define NETLINK_MAJOR   36 */
#define ADC_MAJOR 36
#define base_adc 0x17A

int adc_read (struct inode *inode, struct file *filp, char *buf, int count)
  {int retval=0;printk("adc : read requested\n");
   retval=(inw(base_adc)-65535+4096);return(retval);}

int adc_write(struct inode *inode, struct file *filp,const char *buf, int count)
  {printk("adc : write requested\n"); outw(65535,base_adc); return(0);}

void adc_release(struct inode * inode, struct file * file) {}

static int adc_open(struct inode * inode, struct file * file) {return(0);}

struct file_operations adc_fops = 
  {NULL /* lseek*/, 
   adc_read,adc_write,NULL,NULL,NULL,NULL, /* readdir, select, ioctl, mmap*/
   adc_open,adc_release,NULL,NULL,}; /* nothing more, fill with NULLs */

int init_module(void) 
{int err;
 if ((err=check_region(base_adc,1))<0) return err; /* busy */
 request_region(base_adc,1,"adc"); 
/* the device must have been created previously with 
    mknod /dev/adc c 6 5       (major=6, minor=5) */
 err=register_chrdev(ADC_MAJOR,"adc",&adc_fops);
 if (err<0) {printk("unable to get major %d for adc\n", ADC_MAJOR);
             release_region(base_adc,1);}
    else printk("adc module loaded : major=%d\n", ADC_MAJOR);
 return 0; 
}

void cleanup_module(void){
  unregister_chrdev(ADC_MAJOR,"adc");
  release_region(base_adc,1);printk("adc released\n");}
